import { _ as _async_to_generator } from "@swc/helpers/_/_async_to_generator";
import { _ as _ts_generator } from "@swc/helpers/_/_ts_generator";
import path from "path";
import { fs as fse, getInternalPlugins } from "@modern-js/utils";
import { getProjectUsage } from "./utils";
import { handleDependencies } from "./dependencies";
function deploy_default() {
  return {
    name: "@modern-js/plugin-deploy",
    pre: [
      "@modern-js/plugin-bff",
      "@modern-js/plugin-server"
    ],
    setup: function(api) {
      return {
        beforeDeploy: function beforeDeploy() {
          return _async_to_generator(function() {
            var deployTarget, appContext, appDirectory, distDirectory, serverInternalPlugins, sharedDirectory, apiDirectory, lambdaDirectory, metaName, configContext, outputDirectory, funcsDirectory, staticDirectory, bff, config, plugins, serverAppContext, code, genNodeEntry, genVercelEntry, genNetlifyEntry, _getProjectUsage, useSSR, useAPI, useWebServer, entryFilePath;
            return _ts_generator(this, function(_state) {
              switch (_state.label) {
                case 0:
                  deployTarget = process.env.MODERNJS_DEPLOY || "node";
                  appContext = api.useAppContext();
                  appDirectory = appContext.appDirectory, distDirectory = appContext.distDirectory, serverInternalPlugins = appContext.serverInternalPlugins, sharedDirectory = appContext.sharedDirectory, apiDirectory = appContext.apiDirectory, lambdaDirectory = appContext.lambdaDirectory, metaName = appContext.metaName;
                  configContext = api.useResolvedConfigContext();
                  outputDirectory = path.join(appDirectory, ".output");
                  funcsDirectory = outputDirectory;
                  staticDirectory = path.join(outputDirectory, "static");
                  return [
                    4,
                    fse.remove(outputDirectory)
                  ];
                case 1:
                  _state.sent();
                  if (!(deployTarget === "node"))
                    return [
                      3,
                      3
                    ];
                  return [
                    4,
                    fse.copy(distDirectory, outputDirectory, {
                      filter: function(src) {
                        var distStaticDirectory = path.join(distDirectory, "static");
                        return !src.includes(distStaticDirectory);
                      }
                    })
                  ];
                case 2:
                  _state.sent();
                  _state.label = 3;
                case 3:
                  if (!(deployTarget === "vercel"))
                    return [
                      3,
                      7
                    ];
                  funcsDirectory = path.join(outputDirectory, "functions");
                  staticDirectory = path.join(outputDirectory, "static");
                  return [
                    4,
                    fse.copy(distDirectory, funcsDirectory, {
                      filter: function(src) {
                        var distStaticDirectory = path.join(distDirectory, "static");
                        return !src.includes(distStaticDirectory);
                      }
                    })
                  ];
                case 4:
                  _state.sent();
                  return [
                    4,
                    fse.copy(path.join(distDirectory, "static"), staticDirectory)
                  ];
                case 5:
                  _state.sent();
                  return [
                    4,
                    fse.writeJSON(path.join(funcsDirectory, ".vc-config.json"), {
                      runtime: "nodejs16.x",
                      handler: "index.js",
                      launcherType: "Nodejs",
                      shouldAddHelpers: false,
                      supportsResponseStreaming: true
                    })
                  ];
                case 6:
                  _state.sent();
                  _state.label = 7;
                case 7:
                  bff = configContext.bff;
                  config = {
                    output: {
                      path: "."
                    },
                    bff
                  };
                  plugins = getInternalPlugins(appDirectory, serverInternalPlugins);
                  serverAppContext = {
                    sharedDirectory: 'path.join(__dirname, "'.concat(path.relative(appDirectory, sharedDirectory), '")'),
                    apiDirectory: 'path.join(__dirname, "'.concat(path.relative(appDirectory, apiDirectory), '")'),
                    lambdaDirectory: 'path.join(__dirname, "'.concat(path.relative(appDirectory, lambdaDirectory), '")'),
                    metaName
                  };
                  code = "";
                  console.log("deployTarget111111111", deployTarget);
                  switch (deployTarget) {
                    case "node":
                      return [
                        3,
                        8
                      ];
                    case "vercel":
                      return [
                        3,
                        10
                      ];
                    case "netlify":
                      return [
                        3,
                        12
                      ];
                  }
                  return [
                    3,
                    14
                  ];
                case 8:
                  return [
                    4,
                    import("./entrys/node")
                  ];
                case 9:
                  genNodeEntry = _state.sent().genNodeEntry;
                  code = genNodeEntry({
                    plugins,
                    config,
                    appContext: serverAppContext
                  });
                  return [
                    3,
                    15
                  ];
                case 10:
                  return [
                    4,
                    import("./entrys/vercel")
                  ];
                case 11:
                  genVercelEntry = _state.sent().genVercelEntry;
                  code = genVercelEntry({
                    plugins,
                    config,
                    appContext: serverAppContext
                  });
                  return [
                    3,
                    15
                  ];
                case 12:
                  return [
                    4,
                    import("./entrys/netlify")
                  ];
                case 13:
                  genNetlifyEntry = _state.sent().genNetlifyEntry;
                  code = genNetlifyEntry({
                    plugins,
                    config,
                    appContext: serverAppContext
                  });
                  return [
                    3,
                    15
                  ];
                case 14:
                  {
                    code = 'throw new Error("unknown deploy target, MODERNJS_DEPLOY should be set");';
                  }
                  _state.label = 15;
                case 15:
                  _getProjectUsage = getProjectUsage(appDirectory, distDirectory), useSSR = _getProjectUsage.useSSR, useAPI = _getProjectUsage.useAPI, useWebServer = _getProjectUsage.useWebServer;
                  entryFilePath = path.join(funcsDirectory, "index.js");
                  if (!(useSSR || useAPI || useWebServer))
                    return [
                      3,
                      17
                    ];
                  return [
                    4,
                    fse.writeFile(entryFilePath, code)
                  ];
                case 16:
                  _state.sent();
                  _state.label = 17;
                case 17:
                  return [
                    4,
                    handleDependencies(appDirectory, funcsDirectory, [
                      "@modern-js/prod-server"
                    ])
                  ];
                case 18:
                  _state.sent();
                  return [
                    2
                  ];
              }
            });
          })();
        }
      };
    }
  };
}
;
export {
  deploy_default as default
};
